/* eslint-disable */
import fs from 'fs';
import path from 'path';
import mkdirp from 'mkdirp';
import program from 'commander';

const componentDir = path.join('./', 'src', 'components');

const generateReactComponent = ({ name = 'MyComponent' } = {}) => (
`import React from 'react';

export default class ${name} extends React.Component {
  render() {
    return (
      <div />
    );
  }
}

${name}.propTypes = {
  prop1: React.PropTypes.string.isRequired.describe('Replace me with the actual props'),
};
`
);


(() => {
  program
    .option('-n, --name [name]', '')
    .parse(process.argv);
  const { name } = program;

  /* check component name */
  if (!name || typeof name === 'function') {
    console.log([
      'No component name specified!',
      '',
      'Usage: npm run generate <name>',
      '',
      '  name - The name of the component you wish to create a scaffold for',
    ].join('\n'));
    return;
  }

  /* check exists */
  try {
    fs.statSync(path.join(componentDir, name));
    // If we don't error, the file exists
    console.log('Error: A component with that name already exists!');
    process.exit(1);
  } catch (e) {}

  try {
    mkdirp.sync(path.join(componentDir, name));
    fs.writeFileSync(path.join(componentDir, name, `${name}.js`), generateReactComponent({ name }));

    console.log(`Component ${name} created at ${path.join(componentDir, name)}.`);
  } catch (e) {
    console.log(e);
    console.log('Error: Failed to create files.');
    process.exit(1);
  }
})();
